/*******************************************************************************
 * shroudBNC - an object-oriented framework for IRC                            *
 * Copyright (C) 2005 Gunnar Beutner                                           *
 *                                                                             *
 * This program is free software; you can redistribute it and/or               *
 * modify it under the terms of the GNU General Public License                 *
 * as published by the Free Software Foundation; either version 2              *
 * of the License, or (at your option) any later version.                      *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program; if not, write to the Free Software                 *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *******************************************************************************/

class CBouncerConfig {
	CHashtable<char *, false, 8> *m_Settings;

	char *m_File;
	bool m_WriteLock;

	bool ParseConfig(void);
	bool Persist(void);
public:
#ifndef SWIG
	CBouncerConfig(const char *Filename);
#endif
	virtual ~CBouncerConfig(void);

	virtual int ReadInteger(const char *Setting);
	virtual const char *ReadString(const char *Setting);

	virtual bool WriteInteger(const char *Setting, const int Value);
	virtual bool WriteString(const char *Setting, const char *Value);

	virtual xhash_t<char *> *Iterate(int Index);

	virtual const char *GetFilename(void);
};
